﻿
package{

	import Box2D.Dynamics.*
	import Box2D.Collision.*
	import Box2D.Collision.Shapes.*
	import Box2D.Dynamics.Joints.*
	import Box2D.Dynamics.Contacts.*
	import Box2D.Common.Math.*
	import com.bit101.components.ComboBox;
	import com.gskinner.motion.GTween;
	import fl.motion.easing.Back;
	import flash.events.Event;
	import flash.display.*;
	import flash.events.KeyboardEvent;
	import flash.filters.GlowFilter;
	import flash.geom.Rectangle;
	import flash.text.*;


	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import com.bit101.components.Knob;
	import flash.utils.getTimer;
	import flash.geom.Point;

	/**
	 * ...
	 * @author EduardRuzga www.wonderwhy-er.com
	 * Game made for LudumDare 21 compo
	 */
	
	public class Main extends MovieClip {
		
		var bodyParts:Array = [];
		var bodyPartsHash:Object = {};
		var debug:TextField;
		var playing:Boolean = true;
		public var m_currId:int = 0;
		public var sandBox:SandBox;
		static public var m_sprite:Sprite;
		static public var ui:Sprite;
		static public var dragedJoint:Sprite;
		
		public static var _instance:Main;
		
		public var selecting:Boolean = false;
		public var selectionStartX:Number = 0;
		public var selectionStartY:Number = 0;
	
		
		public var glow:GlowFilter = new GlowFilter(0xFF0000);
		
		
		
		public function Main(){
			
			addEventListener(Event.ENTER_FRAME, update, false, 0, true);
			
			_instance = this;
			
			m_sprite = new Sprite();
			m_sprite.name = "Engine";
			addChild(m_sprite);
			
			m_sprite.mouseEnabled = false;
			
			ui = new Sprite();
			ui.mouseEnabled = ui.mouseChildren = false;
			addChild(ui);
			// input
			
			var hints:TextField = new TextField();
			hints.mouseEnabled = false;
			hints.autoSize = TextFieldAutoSize.LEFT;
			hints.textColor = 0xFFFFFF;
			hints.defaultTextFormat = new TextFormat(null, 14);
			hints.text = "Story: you are on a space station,\n gravity went off, \nnow you need to get to the button to turn it on again" 
			+"\n\n Controls:\n- click on joints and drag to set angles\n-click anywhere and drag to select multiple joints and relax or fixate them\n-use space to pause the game for more precise and simulatious commands joint edditing\n-press R to restart";
			ui.addChild(hints);
			
			//hints.x = -hints.width;
			
			stage.addEventListener(MouseEvent.MOUSE_UP, OnMouseRelease);
			
			debug = new TextField();
			debug.autoSize = TextFieldAutoSize.LEFT;
			debug.x = 300;
			addChild(debug);
			
			stage.addEventListener(KeyboardEvent.KEY_DOWN, OnKeyDown);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, OnStageDrag);
			
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT
			//stage.displayState = StageDisplayState.FULL_SCREEN;
		}
		
		public function OnKeyDown(e:KeyboardEvent):void
		{
			switch(e.keyCode)
			{
				case 32:
					playing = !playing;
				break;
				case 82:
					sandBox = null;
					pressed = false;
					while (m_sprite.numChildren>0)
					{
						m_sprite.removeChildAt(0);
					}
					bodyParts = [];
				break;
			}
		}
		
		public function formatRadians(n:Number):Number
		{
			return Math.round(n * 180 / Math.PI);
		}
		
		var pressed:Boolean = false;
		
		public function ButtonPress():void
		{
			if (!pressed)
			{
				pressed = true;
				var t:GTween = new GTween(SandBox._instance.gravity, 1, { }, { delay:1, ease:fl.motion.easing.Back.easeOut } );
				t.proxy.x = 0;
				t.proxy.y = 10;
				
				var spr:Sprite = new Sprite();
				spr.graphics.beginFill(0);
				spr.graphics.drawRect(0, 0, stage.stageWidth, stage.stageHeight);
				var theEnd:TextField = new TextField();
				theEnd.textColor = 0xFFFFFF;
				theEnd.defaultTextFormat = new TextFormat(null, 20);
				theEnd.text = "To be conitnued... Hopefully. \nClick to see how clumsy austraunauts are with gravity :D";
				theEnd.autoSize = TextFieldAutoSize.LEFT;
				theEnd.x = (stage.stageWidth - theEnd.width) / 2;
				theEnd.y = (stage.stageHeight - theEnd.height) / 2;
				//theEnd.embedFonts = true;
				spr.addChild(theEnd);
				addChild(spr);
				spr.alpha = 0;
				t = new GTween(spr, 1, { }, { delay:0, ease:fl.motion.easing.Back.easeOut } );
				t.proxy.x = 0;
				t.proxy.y = 10;
				
				spr.addEventListener(MouseEvent.CLICK, Remove);
				
				t = new GTween(spr, 1, { }, { delay:2, ease:fl.motion.easing.Back.easeOut } );
				t.proxy.alpha = 1;
			}
		}
		
		public function Remove(e:Event):void
		{
			removeChild(e.currentTarget as Sprite);
			
		}
		
		public function update(e:Event):void{
			// clear for rendering
			m_sprite.graphics.clear()
			//trace(m_currTest.m_world.m_jointCount)
			
			// if null, set new test
			if (!sandBox) {
				sandBox = new SandBox();
				var itms:Array = [];
				for (var key:String in sandBox.muscles)
				{
					itms.push(key);
					var info:Object = { name:key, "joint":sandBox.muscles[key], "angle":0, "state":false };
					bodyPartsHash[key] = info;						
					bodyParts.push( info  );
				}
				
			}
			ui.graphics.clear();
			
			var scale:Number = 30;
			
			//trace(BodyPartBox.items.length);
			// update current test
			if (playing)
			{
				sandBox.Update();
				var headPos:b2Vec2 = (bodyPartsHash["neck"].joint as b2Joint).GetBody1().GetPosition().Copy();
				headPos.Multiply(scale);
				ui.x = m_sprite.x = -headPos.x+stage.stageWidth/2;
				ui.y = m_sprite.y = -headPos.y+stage.stageHeight/2;

			}
			

			
			
			
			var body:b2Body = sandBox.m_world.m_bodyList;
			while (body)
			{
				if (body.m_userData != null)
				{
					var sp:Sprite = body.m_userData as Sprite;
					if(sp){
						if (sp.parent != m_sprite)
						{
							m_sprite.addChild(sp);
						}
						var pos:b2Vec2 = body.GetPosition();
						sp.x = pos.x*scale;
						sp.y = pos.y * scale;
						sp.rotation = body.GetAngle() * (180 / Math.PI);
					}
				}
				body = body.GetNext();
			}
			var dir:b2Vec2;
			
			if (dragedJoint)
			{
				if(!dragedJoint.hitTestPoint(dragedJoint.mouseX,dragedJoint.mouseY,true))
				{

					var i:uint = int(dragedJoint.name);
					var bodyPartInfo:Object = bodyParts[i];
					if(!bodyPartInfo.state && (getTimer()-mouseDownTime)>100)
						bodyPartInfo.state = true;
					var joint:b2RevoluteJoint = bodyPartInfo.joint as b2RevoluteJoint;
					
					var angle:Number;// = Math.atan2(m_sprite.mouseY - dragedJoint.y, m_sprite.mouseX - dragedJoint.x);
					//if(m_sprite.mouseY - dragedJoint.y>0)
						//angle-=Math.PI*2;
					
					var vec:b2Vec2 = new b2Vec2(dragedJoint.x - m_sprite.mouseX, dragedJoint.y - m_sprite.mouseY);
					var newAngle:Number = Math.atan2(vec.y, vec.x);
					
					
					var baseVec:b2Vec2 = joint.m_localAnchor2.Copy();
					baseVec.Subtract(joint.GetBody2().GetLocalCenter());
					var baseAgnle:Number = Math.atan2(baseVec.y, baseVec.x);

					//var baseVec2:b2Vec2 = joint.m_localAnchor1.Copy();
					//baseVec2.Subtract(joint.GetBody1().GetLocalCenter());
					//var baseAgnle2:Number = Math.atan2(baseVec2.y, baseVec2.x);


					
					//hack
					if (bodyPartInfo.name.indexOf("Elbow") < 0 && bodyPartInfo.name.indexOf("Shoulder") < 0)
					{
						baseAgnle += Math.PI;
					}
					
					var finalAngle:Number = (newAngle + baseAgnle) - bringDownRadian(joint.GetBody1().GetAngle());
					
					if (finalAngle > Math.PI)
						finalAngle -= Math.PI * 2;
					else if (finalAngle < -Math.PI)
						finalAngle += Math.PI * 2;
					
					finalAngle = Math.max(joint.GetLowerLimit(), Math.min(joint.GetUpperLimit(), finalAngle));	
					
					
					
					bodyPartInfo.angle = finalAngle;
					
					
					//debug.text = formatRadians(finalAngle).toString();
					
					
					ui.graphics.lineStyle(1, 0xFF0000);
					ui.graphics.moveTo(dragedJoint.x, dragedJoint.y);
					ui.graphics.lineTo(m_sprite.mouseX, m_sprite.mouseY);


					
					/*var otherSp:Sprite = (joint as b2RevoluteJoint).GetBody1().m_userData as Sprite;
					
					var dir:b2Vec2;// = (joint as b2RevoluteJoint).GetAnchor1().Copy();
					//dir.Multiply(scale);
					var p:Point = otherSp.globalToLocal(new Point(dragedJoint.x, dragedJoint.y));
					
					
					otherSp.graphics.clear();
					otherSp.graphics.lineStyle(1, 0xFF0000);
					otherSp.graphics.moveTo(p.x, p.y);
					otherSp.graphics.lineTo(otherSp.mouseX, otherSp.mouseY);

					
					p.x=otherSp.mouseX - p.x;
					p.y=otherSp.mouseY - p.y;
										
					//dir.Subtract((joint as b2RevoluteJoint).GetAnchor1()); 
					
					angle =  Math.atan2(p.y,p.x);
					debug.text = "angle:" + angle*(180/Math.PI);
					//if (angle > Math.PI) 
						//angle-= Math.PI;
					//else if (angle < -Math.PI) 
						//angle += Math.PI;
					
					bodyPartInfo.angle = Math.max(joint.GetLowerLimit(),Math.min(joint.GetUpperLimit(),angle));*/
				}
			}
			var selectionRect:Rectangle;
			if (selecting)
			{
				ui.graphics.lineStyle(1, 0xFFFF00);
				selectionRect = new Rectangle(Math.min(m_sprite.mouseX, selectionStartX), Math.min(m_sprite.mouseY, selectionStartY), Math.abs(m_sprite.mouseX - selectionStartX), Math.abs(m_sprite.mouseY - selectionStartY));
				ui.graphics.drawRect(selectionRect.x,selectionRect.y,selectionRect.width,selectionRect.height);
				
			}
			
			for (i = 0; i < bodyParts.length; i++)
			{
				bodyPartInfo = bodyParts[i];
				joint = bodyPartInfo.joint as b2RevoluteJoint;
				sp = joint.m_userData as Sprite;
				if (sp)
				{
					if (sp.parent != m_sprite)
					{
						m_sprite.addChild(sp);
						sp.name = i.toString();
						sp.addEventListener(MouseEvent.MOUSE_OVER, OnJointOver);
						sp.addEventListener(MouseEvent.MOUSE_DOWN, OnJointDrag);
					}
					
					if (selecting)
					{
						var bounds:Rectangle = sp.getBounds(m_sprite);
						if (bounds.intersects(selectionRect))
						{
							sp.filters = [glow];
						}
						else 
						{
							sp.filters = [];
						}
					}
					else
						sp.filters = [];
						
						
					var center:b2Vec2 = joint.GetAnchor1();
					center.Add(joint.GetAnchor2());
					center.Multiply(0.5);
					sp.x = center.x*scale;
					sp.y = center.y * scale;
					dir = (joint as b2RevoluteJoint).GetBody2().GetPosition().Copy();
					dir.Subtract((joint as b2RevoluteJoint).GetAnchor2());
					var ang:Number = Math.atan2(dir.y,dir.x)* (180 / Math.PI);
					sp.rotation = ang;// (joint as b2RevoluteJoint).GetBody2().GetAngle() * (180 / Math.PI);
					sp.alpha = 0.5 + (bodyPartInfo.state?0.5:0);
				}
				
				if (bodyParts[i].state)
				{
					(joint as b2RevoluteJoint).m_enableMotor = true;
					var angleDif:Number = joint.GetJointAngle() - Number(bodyPartInfo.angle);///(180/Math.PI);
					//trace("dif:"+angleDif);
					if(angleDif!=0)
						joint.SetMotorSpeed( -5 * angleDif);
				}
				else
				{
					(joint as b2RevoluteJoint).m_enableMotor = false;
				}
			}					
		}
		
		public function bringDownRadian(n:Number):Number
		{
			var res:Number = n%(Math.PI*2);
			return res;
		}
		
		public function OnStageDrag(e:Event):void
		{
			if (e.target == stage)
			{
				selecting = true;
				selectionStartX = m_sprite.mouseX;
				selectionStartY = m_sprite.mouseY;
			}
		}
		
		public function OnMouseRelease(e:Event):void
		{
			if(dragedJoint)
			{
				var i:uint = int(dragedJoint.name);
				var bodyPartInfo:Object = bodyParts[i];
				var joint:b2RevoluteJoint = bodyPartInfo.joint as b2RevoluteJoint;
				joint.SetMotorSpeed(0);
				dragedJoint = null;
			}
			if (selecting)
			{
				selecting = false;
				var selected:Array = [];
				var activeCount:int = 0;
				var unactiveCount:int = 0;
				var selectionRect:Rectangle = new Rectangle(Math.min(m_sprite.mouseX, selectionStartX), Math.min(m_sprite.mouseY, selectionStartY), Math.abs(m_sprite.mouseX - selectionStartX), Math.abs(m_sprite.mouseY - selectionStartY));
				for (i = 0; i < bodyParts.length; i++)
				{
					bodyPartInfo = bodyParts[i];
					joint = bodyPartInfo.joint as b2RevoluteJoint;
					var sp:Sprite = joint.m_userData as Sprite;
					sp.filters = [];
					var bounds:Rectangle = sp.getBounds(m_sprite);
					if (bounds.intersects(selectionRect))
					{
						selected.push(bodyPartInfo);
						if (bodyPartInfo.state)
							activeCount++
						else
							unactiveCount++
					}
				}
				var newState:Boolean = unactiveCount>activeCount;
				for (i = 0; i < selected.length; i++)
				{
					selected[i].state = newState;
					
					selected[i].angle = selected[i].joint.GetJointAngle();
				}
			}
		}
		
		var mouseDownTime:Number;
		
		public function OnJointDrag(e:Event):void
		{
			mouseDownTime = getTimer();
			dragedJoint = e.currentTarget as Sprite;
			var i:uint = int(dragedJoint.name);
			var bodyPartInfo:Object = bodyParts[i];
			var joint:b2RevoluteJoint = bodyPartInfo.joint as b2RevoluteJoint;
			if (bodyPartInfo.state)
			{
				bodyPartInfo.state = false;
			}
			else
			{
				bodyPartInfo.state = true;
				bodyPartInfo.angle = joint.GetJointAngle();// * (180 / Math.PI);
			}
		}
		
		public function OnJointOver(e:Event):void
		{
			//trace((e.currentTarget as DisplayObject).rotation);
			//
			//var sp:Sprite = e.currentTarget as Sprite;
			//var i:uint = int(sp.name);
			//trace(sp.rotation);
			//var bodyPartInfo:Object = bodyParts[i];
			//var joint:b2RevoluteJoint = bodyPartInfo.joint as b2RevoluteJoint;
			//trace(joint.m_referenceAngle * 180 / Math.PI);
			//var a1:Number = joint.GetBody1().GetAngle();
			//var a2:Number = joint.GetBody2().GetAngle();
			//var a3:Number = joint.GetJointAngle();
			//trace(a1, a2, a3);
			/*if((getTimer()-mouseDownTime))
			{
				var sp:Sprite = e.currentTarget as Sprite;
				var i:uint = int(sp.name);
				var bodyPartInfo:Object = bodyParts[i];
				var joint:b2RevoluteJoint = bodyPartInfo.joint as b2RevoluteJoint;
				if (bodyPartInfo.state)
				{
					bodyPartInfo.state = false;
				}
				else
				{
					bodyPartInfo.state = true;
					bodyPartInfo.angle = joint.GetJointAngle();// * (180 / Math.PI);
				}
			}*/
		}

	}
}