﻿

package {
	
	
	
	import Box2D.Dynamics.*;
	import Box2D.Collision.*;
	import Box2D.Collision.Shapes.*;
	import Box2D.Dynamics.Joints.*;
	import Box2D.Dynamics.Contacts.*;
	import Box2D.Common.*;
	import Box2D.Common.Math.*;
	import com.gskinner.motion.GTween;
	import Main;
	
	import flash.utils.getTimer
	import flash.display.*;
	import fl.motion.easing.Back;
	
	/**
	 * ...
	 * @author EduardRuzga www.wonderwhy-er.com
	 * Game made for LudumDare 21 compo
	 */	
	
	public class SandBox{
		
		public var muscles:Array;
		public var m_world:b2World;
		public var m_bomb:b2Body;
		public var m_mouseJoint:b2MouseJoint;
		public var m_iterations:int = 10;
		public var m_timeStep:Number = 1/30;
		public var m_physScale:Number = 30;
		// Sprite to draw in to
		public var m_sprite:Sprite;
		public var m_door1Motor:b2PrismaticJoint;
		
		static var CostumeColor:uint = 0xcccccc;
		
		public var contactListener:ContactListener;
		
		public var BodyParts:Array;
		
		public var button:b2Body;
		
		static var _instance:SandBox;
		
		public var gravity:b2Vec2;
		
		public function SandBox(){
			
			m_sprite = Main.m_sprite;
			
			_instance = this;
			
			var worldAABB:b2AABB = new b2AABB();
			worldAABB.lowerBound.Set(-1000.0, -1000.0);
			worldAABB.upperBound.Set(1000.0, 1000.0);
			
			
			
			// Define the gravity vector
			gravity = new b2Vec2(0.0, 10.0);
			
			// Allow bodies to sleep
			var doSleep:Boolean = true;
			
			// Construct a world object
			m_world = new b2World(worldAABB, gravity, doSleep);
			// set debug draw
			/*var dbgDraw:b2DebugDraw = new b2DebugDraw();
			var dbgSprite:Sprite = new Sprite();
			m_sprite.addChild(dbgSprite);
			dbgDraw.m_sprite = m_sprite;
			dbgDraw.m_drawScale = 30.0;
			dbgDraw.m_fillAlpha = 1;
			dbgDraw.m_lineThickness = 1.0;
			dbgDraw.m_drawFlags = b2DebugDraw.e_shapeBit | b2DebugDraw.e_jointBit;
			m_world.SetDebugDraw(dbgDraw);*/
			
			contactListener = new ContactListener();
			m_world.SetContactListener(contactListener);
			
			var t:GTween = new GTween(gravity, 1, { }, { delay:1, ease:fl.motion.easing.Back.easeOut } );
			t.proxy.x = 0;
			t.proxy.y = 0;
			// Create border of boxes
			
			var bd:b2BodyDef;
			var circ:b2CircleDef = new b2CircleDef();
			var box:b2PolygonDef = new b2PolygonDef();
			var jd:b2RevoluteJointDef = new b2RevoluteJointDef();
			var friction:Number = 0.7;
			var restitiution :Number = 0.3;
			muscles = [];
			BodyParts = [];
			{
				var startX:Number = 250;
				var startY:Number = 200;
				
				// BODIES
				
				// Head
				circ.radius = 12.5 / m_physScale;
				circ.density = 1.0;
				circ.friction = friction;				
				circ.restitution = restitiution;
				//circ.filter.groupIndex = -1;
				bd = new b2BodyDef();
				bd.allowSleep = false;
				bd.position.Set(startX / m_physScale, (startY+3) / m_physScale);
				var head:b2Body = m_world.CreateBody(bd);
				head.m_userData = CreateHelmet(12.5);
				head.CreateShape(circ);
				head.SetMassFromShapes();
				BodyParts.push(head);
				
				// Torso1
				box.SetAsBox(20 / m_physScale, 10 / m_physScale);
				box.density = 1.0;
				box.friction = friction;				box.restitution = 0.1;
				//box.filter.groupIndex = -1;
				bd = new b2BodyDef();
				bd.position.Set(startX / m_physScale, (startY + 28) / m_physScale);
				var torso1:b2Body = m_world.CreateBody(bd);
				torso1.CreateShape(box);
				torso1.SetMassFromShapes();
				BodyParts.push(torso1);
				
				torso1.m_userData = CreateBoxSprite(CostumeColor,20,10);
				// Torso2
				box.SetAsBox(10 / m_physScale, 10 / m_physScale);
				bd = new b2BodyDef();
				bd.position.Set(startX / m_physScale, (startY + 43) / m_physScale);
				var torso2:b2Body = m_world.CreateBody(bd);
				torso2.CreateShape(box);
				torso2.SetMassFromShapes();
				torso2.m_userData = CreateBoxSprite(CostumeColor, 10, 10);
				BodyParts.push(torso2);
				// Torso3
				bd = new b2BodyDef();
				box.SetAsBox(15 / m_physScale, 10 / m_physScale);
				bd.position.Set(startX / m_physScale, (startY + 58) / m_physScale);
				var torso3:b2Body = m_world.CreateBody(bd);
				torso3.CreateShape(box);
				torso3.SetMassFromShapes();
				torso3.m_userData = CreateBoxSprite(CostumeColor, 15, 10);
				BodyParts.push(torso3);
				// UpperArm
				box.SetAsBox(18 / m_physScale, 6.5 / m_physScale);
				box.density = 1.0;
				box.friction = friction;				box.restitution = 0.1;
				//box.filter.groupIndex = -1;
				bd = new b2BodyDef();
				// L
				bd.position.Set((startX - 33) / m_physScale, (startY + 20) / m_physScale);
				var upperArmL:b2Body = m_world.CreateBody(bd);
				upperArmL.CreateShape(box);
				upperArmL.SetMassFromShapes();
				upperArmL.m_userData = CreateBoxSprite(CostumeColor, 18, 6.5);
				BodyParts.push(upperArmL);
				// R
				bd.position.Set((startX + 33) / m_physScale, (startY + 20) / m_physScale);
				var upperArmR:b2Body = m_world.CreateBody(bd);
				upperArmR.CreateShape(box);
				upperArmR.SetMassFromShapes();
				upperArmR.m_userData = CreateBoxSprite(CostumeColor, 18, 6.5);
				BodyParts.push(upperArmR);
				// LowerArm
				box.SetAsBox(18/ m_physScale, 6 / m_physScale);
				box.density = 1.0;
				box.friction = friction;				box.restitution = 0.1;
				//box.filter.groupIndex = -1;
				bd = new b2BodyDef();
				
				
				// L
				bd.position.Set((startX - 61) / m_physScale, (startY + 20) / m_physScale);
				var lowerArmL:b2Body = m_world.CreateBody(bd);
				lowerArmL.CreateShape(box);
				lowerArmL.SetMassFromShapes();
				lowerArmL.m_userData = CreateBoxSprite(CostumeColor, 17, 6);
				BodyParts.push(lowerArmL);
				// R
				bd.position.Set((startX + 61) / m_physScale, (startY + 20) / m_physScale);
				var lowerArmR:b2Body = m_world.CreateBody(bd);
				lowerArmR.CreateShape(box);
				lowerArmR.SetMassFromShapes();
				lowerArmR.m_userData = CreateBoxSprite(CostumeColor, 17, 6);
				BodyParts.push(lowerArmR);
				
				//palms
				
				
				
				// UpperLeg
				box.SetAsBox(8 / m_physScale, 24 / m_physScale);
				box.density = 2.0;
				box.friction = friction;				
				box.restitution = restitiution;
				box.filter.groupIndex = -1;
				bd = new b2BodyDef();
				// L
				bd.position.Set((startX - 8) / m_physScale, (startY + 86) / m_physScale);
				var upperLegL:b2Body = m_world.CreateBody(bd);
				upperLegL.CreateShape(box);
				upperLegL.SetMassFromShapes();
				upperLegL.m_userData = CreateBoxSprite(CostumeColor, 7.5, 22);
				BodyParts.push(upperLegL);
				// R
				bd.position.Set((startX + 8) / m_physScale, (startY + 86) / m_physScale);
				var upperLegR:b2Body = m_world.CreateBody(bd);
				upperLegR.CreateShape(box);
				upperLegR.SetMassFromShapes();
				upperLegR.m_userData = CreateBoxSprite(CostumeColor, 7.5, 22);
				BodyParts.push(upperLegR);
				// LowerLeg
				box.SetAsBox(7 / m_physScale, 26 / m_physScale);
				box.density = 2.0;
				box.friction = friction;				
				box.restitution = restitiution;
				box.filter.groupIndex = 0;
				bd = new b2BodyDef();
				// L
				bd.position.Set((startX - 7.5) / m_physScale, (startY + 127) / m_physScale);
				var lowerLegL:b2Body = m_world.CreateBody(bd);
				lowerLegL.CreateShape(box);
				lowerLegL.SetMassFromShapes();
				lowerLegL.m_userData =  CreateBoxSprite(CostumeColor, 8, 26);
				BodyParts.push(lowerLegL);
				// R
				bd.position.Set((startX + 7.5) / m_physScale, (startY + 127) / m_physScale);
				var lowerLegR:b2Body = m_world.CreateBody(bd);
				lowerLegR.CreateShape(box);
				lowerLegR.SetMassFromShapes();
				lowerLegR.m_userData = CreateBoxSprite(CostumeColor, 8, 26);
				BodyParts.push(lowerLegR);
				
				// JOINTS
				jd.enableLimit = true;

				jd.maxMotorTorque = 50.0;
				jd.motorSpeed     = 0.0;
				jd.enableMotor    = true;
				
				// Head to shoulders
				jd.lowerAngle = -40 / (180/Math.PI);
				jd.upperAngle = 40 / (180/Math.PI);
				jd.Initialize(torso1, head, new b2Vec2(startX / m_physScale, (startY + 15) / m_physScale));
				var neck:b2Joint = m_world.CreateJoint(jd);;
				muscles["neck"] = neck;
				
				var jointPointSize:Number = 6;
				
				neck.m_userData = CreateCircleSprite(0xFFFF00, jointPointSize,true,true);

				
				// Upper arm to shoulders
				// L
				jd.maxMotorTorque = 300.0;
				jd.lowerAngle = -85 / (180/Math.PI);
				jd.upperAngle = 130 / (180/Math.PI);
				jd.Initialize(torso1, upperArmL, new b2Vec2((startX - 18) / m_physScale, (startY + 20) / m_physScale));
				muscles["LShoulder"] = m_world.CreateJoint(jd);
				muscles["LShoulder"].m_userData = CreateCircleSprite(0xFFFF00,jointPointSize,true,true);
				
				//jd.enableMotor    = false;
				// R
				jd.lowerAngle = -130 / (180/Math.PI);
				jd.upperAngle = 85 / (180/Math.PI);
				jd.Initialize(torso1, upperArmR, new b2Vec2((startX + 18) / m_physScale, (startY + 20) / m_physScale));
				muscles["RShoulder"] = m_world.CreateJoint(jd);
				muscles["RShoulder"].m_userData = CreateCircleSprite(0xFFFF00, jointPointSize,true,true);
				// Lower arm to upper arm
				// L
				jd.lowerAngle = -130 / (180/Math.PI);
				jd.upperAngle = 130 / (180/Math.PI);
				jd.Initialize(upperArmL, lowerArmL, new b2Vec2((startX - 45) / m_physScale, (startY + 20) / m_physScale));
				muscles["LElbow"] = m_world.CreateJoint(jd);
				muscles["LElbow"].m_userData = CreateCircleSprite(0xFFFF00,jointPointSize,true,true);
				// R
				jd.lowerAngle = -130 / (180/Math.PI);
				jd.upperAngle = 130 / (180/Math.PI);
				jd.Initialize(upperArmR, lowerArmR, new b2Vec2((startX + 45) / m_physScale, (startY + 20) / m_physScale));
				muscles["RElbow"] = m_world.CreateJoint(jd);
				muscles["RElbow"].m_userData = CreateCircleSprite(0xFFFF00, jointPointSize,true,true);
				// Shoulders/stomach
				jd.maxMotorTorque = 50.0;
				jd.lowerAngle = -15 / (180/Math.PI);
				jd.upperAngle = 15 / (180/Math.PI);
				jd.Initialize(torso1, torso2, new b2Vec2(startX / m_physScale, (startY + 35) / m_physScale));
				muscles["UPress"] = m_world.CreateJoint(jd);
				muscles["UPress"].m_userData = CreateCircleSprite(0xFFFF00, jointPointSize,true,true);
				// Stomach/hips
				jd.Initialize(torso2, torso3, new b2Vec2(startX / m_physScale, (startY + 50) / m_physScale));
				muscles["DPress"] = m_world.CreateJoint(jd);
				muscles["DPress"].m_userData = CreateCircleSprite(0xFFFF00,jointPointSize,true,true);
				// Torso to upper leg
				// L
				jd.maxMotorTorque = 400.0;
				jd.lowerAngle = -25 / (180/Math.PI);
				jd.upperAngle = 135 / (180/Math.PI);
				jd.Initialize(torso3, upperLegL, new b2Vec2((startX - 8) / m_physScale, (startY + 72) / m_physScale));
				muscles["LLeg"] = m_world.CreateJoint(jd);
				muscles["LLeg"].m_userData = CreateCircleSprite(0xFFFF00, jointPointSize,true,true);
				// R
				jd.lowerAngle = -135 / (180/Math.PI);
				jd.upperAngle = 25 / (180/Math.PI);
				jd.Initialize(torso3, upperLegR, new b2Vec2((startX + 8) / m_physScale, (startY + 72) / m_physScale));
				muscles["RLeg"] = m_world.CreateJoint(jd);
				muscles["RLeg"].m_userData = CreateCircleSprite(0xFFFF00, jointPointSize,true,true);
				
				// Upper leg to lower leg
				// L
				jd.lowerAngle = -115 / (180/Math.PI);
				jd.upperAngle = 25 / (180/Math.PI);
				jd.Initialize(upperLegL, lowerLegL, new b2Vec2((startX - 8) / m_physScale, (startY + 105) / m_physScale));
				muscles["LKnee"] = m_world.CreateJoint(jd);
				muscles["LKnee"].m_userData = CreateCircleSprite(0xFFFF00, jointPointSize,true,true);
				// R
				jd.lowerAngle = -25 / (180/Math.PI);
				jd.upperAngle = 115 / (180/Math.PI);
				jd.Initialize(upperLegR, lowerLegR, new b2Vec2((startX + 8) / m_physScale, (startY + 105) / m_physScale));
				muscles["RKnee"] = m_world.CreateJoint(jd);
				muscles["RKnee"].m_userData = CreateCircleSprite(0xFFFF00, jointPointSize,true,true);
			}

			CreateWall(0, 0, 50, 800, 0x000055);
			CreateWall(0, 0, 1000, 50, 0x000055);
			CreateWall(0, 800, 1050, 50, 0x000055);	
			CreateWall(1000, 0, 50, 850, 0x000055);	
			
			CreateWall(0, 400, 800, 30, 0x000055);
			CreateWall(370, 0, 30, 200, 0x000055);
			CreateWall(770, 200, 30, 200, 0x000055);
			
			var boxPileStart:Number = 100;
			for (var i:uint = 0; i < 4; i++)
			{
				CreateBox(boxPileStart + i * 40, 370, 40, 40, 2,0.1, 0x220000);
			}
			for (i = 0; i < 3; i++)
			{
				CreateBox(boxPileStart + i * 40, 330, 40, 40, 2,0.1, 0x220000);
			}			
			CreateBox(boxPileStart+60, 290, 40, 40, 2,0.1, 0x220000);
			for (i = 0; i < 15; i++)
			{
				CreateBox(100+Math.random()*900, 100+Math.random()*700, Math.random()*50+50, 50+Math.random()*50,1,0.1, 0x440000).ApplyForce(new b2Vec2(Math.random()*5, Math.random()*5), new b2Vec2(Math.random()*5, Math.random()*5));
			}
			
			
				// button
				circ = new b2CircleDef();
				circ.radius = 12 / m_physScale;
				circ.isSensor = true;
				
				bd = new b2BodyDef();
				bd.position.Set(200/m_physScale, 600 / m_physScale);
				button = m_world.CreateBody(bd);
				button.m_userData = CreateButton(12);
				button.CreateShape(circ);
				button.SetMassFromShapes();
			
		}
		
		public function CreateBox(x:Number, y:Number, width:Number, height:Number, density:uint = 1,restitution:Number=0.1, color:uint = 0):b2Body
		{
			var bd:b2BodyDef;
			var box:b2PolygonDef = new b2PolygonDef();
			var jd:b2RevoluteJointDef = new b2RevoluteJointDef();
			var friction:Number = 0.7;
			var restitiution :Number = 0.3;
			bd = new b2BodyDef();
			bd.allowSleep = false;
			bd.position.Set((x+width*0.5) / m_physScale, (y+height*0.5) / m_physScale);
			box.SetAsBox(width*0.5 / m_physScale, height*0.5 / m_physScale);
			box.density = density;
			box.friction = friction;				
			box.restitution = restitution;
			var Box:b2Body = m_world.CreateBody(bd);
			Box.CreateShape(box);
			Box.SetMassFromShapes();
			Box.m_userData = CreateBoxSprite(color, width*0.5, height*0.5);
			return Box;
		}
		
		public function CreateWall(x:Number, y:Number, width:Number, height:Number, color:uint=0):void
		{
			var wallSd:b2PolygonDef = new b2PolygonDef();
			var wallBd:b2BodyDef = new b2BodyDef();
			var wallB:b2Body;
			
			wallBd.position.Set((x+width/2)/m_physScale, (y+height/2)/m_physScale);
			wallSd.SetAsBox(width*0.5/m_physScale, height*0.5/m_physScale);
			wallB = m_world.CreateBody(wallBd);
			wallB.CreateShape(wallSd);
			wallB.SetMassFromShapes();
			wallB.m_userData = CreateBoxSprite(color, width*0.5, height*0.5);
		}
		
		
		public static function CreateCircleSprite(color:uint, r:Number, interactive:Boolean = false, line:Boolean = false ):Sprite
		{
			var res:Sprite = new Sprite();
			res.graphics.beginFill(color);
			res.graphics.drawCircle( 0, 0, r);
			res.graphics.endFill();
			if (line)
			{
				res.graphics.lineStyle(1, 0);
				res.graphics.moveTo(-r, 0);
				res.graphics.lineTo(r, 0);
			}
			res.buttonMode = res.mouseEnabled = res.mouseChildren = interactive;
			return res;
		}
		
		public static function CreateButton(r:Number):Sprite
		{
			var res:Sprite = new Sprite();
			res.graphics.beginFill(0x8080dd);
			res.graphics.drawCircle( 0, 0, r);
			res.graphics.endFill();
			res.graphics.beginFill(0xaa0000);
			res.graphics.drawCircle(0,0,-r*0.8);
			return res;
		}
		
		public static function CreateHelmet(r:Number):Sprite
		{
			var res:Sprite = new Sprite();
			res.graphics.beginFill(CostumeColor);
			res.graphics.drawCircle( 0, 0, r);
			res.graphics.endFill();
			res.graphics.beginFill(0x0000aa);
			res.graphics.drawEllipse(-r*0.9, -r*0.7, r * 1.8, r * 1.6);
			res.graphics.endFill();
			res.graphics.beginFill(0xFFFFFF);
			res.graphics.drawCircle( -r * 0.4, -r * 0.2, r * 0.3);
			return res;
		}
		
		public static function CreateBoxSprite(color:uint, hWidth:Number, hHeight:Number,interactive:Boolean=false):Sprite
		{
			var res:Sprite = new Sprite();
			res.graphics.beginFill(color);
			res.graphics.drawRect( -hWidth, -hHeight, hWidth * 2, hHeight * 2);
			res.buttonMode = res.mouseEnabled = res.mouseChildren = interactive;
			res.graphics.endFill();
			return res;
		}
		
		public function Update():void{
			var physStart:uint = getTimer();
			m_world.Step(m_timeStep, m_iterations);
		}
				
		
		

		
		
	
		
		

	}
	
}